package com.vulcannis.icfp2002;

import com.vulcannis.icfp2002.game.*;

public final class BotClient implements GameClient
{
	public BotClient( Bot bot )
	{
		this.bot = bot;
	}
	
	public void initPlayer( GameMap map, ClientConfig config, PlayerUpdate initialState )
	{
		state = new GameState( map );
		state.update( config );
		state.update( initialState );
	}

	public ClientAction startTurn( PackageUpdate update )
	{
		state.update( update );

		System.out.println( "Start of turn." );
		System.out.println( state.getOurPlayer( ) );
		System.out.println( "Money: " + state.getMoney( ) );
		System.out.println( "Opponents: " + state.getOpponents( ) );
		bot.startTurn( state );

		action = bot.getAction( );
		state.update( action );

		System.out.println( "Submitting action: " + action );
		return action;
	}
	
	public void endTurn( PlayerUpdate update )
	{
		state.update( update );

		final boolean actionSuccessful = action.wasSuccessful( state );
		if( !actionSuccessful ) {
			System.out.println( "Action failed!" );
			System.out.println( state.getOurPlayer( ) );
		}
		bot.endTurn( state, actionSuccessful );
		System.out.println( );
	}
	
	private GameState state;
	private Bot bot;
	private ClientAction action;
}
