package com.vulcannis.icfp2002;

import com.vulcannis.icfp2002.game.*;

public interface GameClient
{
	public void initPlayer( GameMap map, ClientConfig config, PlayerUpdate initialState );
	
	/**
	 * Sent at the start of the turn. text contains the package
	 * list for the players location.
	 * @return the command the player wishes to execute
	 */
	public ClientAction startTurn( PackageUpdate update );	
	
	/**
	 * Sent at the end of the turn, text contains the list
	 * of robot locations and actions.
	 */
	public void endTurn( PlayerUpdate update );
}
