package com.vulcannis.icfp2002.bots;

import java.util.*;

import com.vulcannis.icfp2002.game.*;

public class ConstantBidder implements Bidder
{
	public ConstantBidder( )
	{
		this( 1 );
	}
	
	public ConstantBidder( final int bid )
	{
		this.bid = bid;
	}

	public MoveAction getMoveBid( final GameState state, final Direction dir )
	{
		return new MoveAction( bid, dir, state );
	}

	public PickupAction getPickupBid( final GameState state, final Set packages )
	{
		return new PickupAction( bid, packages );
	}

	public DropAction getDropBid( final GameState state, final Set packages )
	{
		return new DropAction( bid, packages );
	}

	private final int bid;
}
