package com.vulcannis.icfp2002.bots;

import java.util.*;

import com.vulcannis.icfp2002.*;
import com.vulcannis.icfp2002.game.*;

public class ExpFailDeliveryBot extends DeliveryBot
{
	public ExpFailDeliveryBot( final PackagePrioritizer packagePrioritizer, final PathPlotter plotter, final ExponentialFailureBidder bidder )
	{
		super( packagePrioritizer, plotter, bidder );
		this.bidder = bidder;
	}

	public void endTurn( final GameState state, boolean actionSuccessful )
	{
		super.endTurn( state, actionSuccessful );
		if( isStuck( state ) )
			actionSuccessful = true;
		else {
			if( action instanceof PickupAction && !actionSuccessful ) {
				System.out.println( "Last pickup was unsuccessful, ignoring packages at " + state.getPreviousLocation( ) );
				state.getPackageInfo( ).addToIgnoreList( Collections.singleton( state.getPreviousLocation( ) ) );
				actionSuccessful = true;
			}
		}
		bidder.update( state, actionSuccessful );
	}

	public static void main( String args[ ] )
	{
		double rate = 2, ratio = 0.5;
		if( args.length > 2 ) {
			rate = Double.parseDouble( args[ 2 ] );
			ratio = Double.parseDouble( args[ 3 ] );
		}
		final ExponentialFailureBidder bidder = new ExponentialFailureBidder( rate, ratio, new OpponentLocationMovePrioritizier( ) );
		Main.runGame( args, new ExpFailDeliveryBot( new LargestPackagesFirst( ), new RepeatingDeliveryPlotter( ), bidder ) );
	}
	
	private ExponentialFailureBidder bidder;
}
