package com.vulcannis.icfp2002.bots;

import java.util.*;

import com.vulcannis.icfp2002.game.*;
import com.vulcannis.icfp2002.game.Package;

public class LargestPackagesFirst implements PackagePrioritizer
{
	public Set getPickupSet( final GameState state, final Set available )
	{
		final HashSet set = new HashSet( );
		final Player us = state.getOurPlayer( );
		
		int availWeight = state.getMaxWeight( ) - us.getCurrentWeight( );
		final Iterator it = available.iterator( );
		while( it.hasNext( ) && availWeight > 0 ) {
			final Package element = (Package)it.next( );
			if( element.getWeight( ) <= availWeight ) {
				set.add( element );
				availWeight -= element.getWeight( );
			}
		}
		return set;
	}
}
