package com.vulcannis.icfp2002.bots;

import com.vulcannis.icfp2002.game.*;
import com.vulcannis.icfp2002.util.*;

public final class OpponentLocationMovePrioritizier implements MovePrioritizer {
	public boolean shouldMoveFirst( final GameState state, final Direction dir )
	{
		final Point location = state.getOurPlayer( ).getLocation( );
		final Point destination = dir.move( location );
		final boolean adjacentToUs = state.isEnemyAdjacentTo( location );
		final boolean adjacentToTarget = state.isEnemyAdjacentTo( destination );
		
		if( adjacentToUs && adjacentToTarget ) {
			conflict = true;
			return true;
		} else {
			conflict = false;
			return adjacentToUs;
		}
	}
	
	public boolean isConflict( )
	{
		return conflict;
	}
	
	private boolean conflict;
}
