package com.vulcannis.icfp2002.bots;

import java.util.*;

import com.vulcannis.icfp2002.game.*;
import com.vulcannis.icfp2002.util.*;

public class RepeatingDeliveryPlotter extends DeliveryPlotter
{
	public Path getNextPath( final GameState state, final Set unreachables )
	{
		final long stopTime = System.currentTimeMillis( ) + 500;
		int attempt = 1;
		Path path = null;
		do {
			System.out.println( "Finding path, try " + attempt++ );
			final Set destinations = getDestinations( state, unreachables );
			path = computePath( destinations, state );
			if( path == null ) {
				final Set temp = SetUtil.subtraction( destinations, Collections.singleton( state.getOurPlayer( ).getLocation( ) ) );
				unreachables.addAll( temp );
				state.getPackageInfo( ).addToIgnoreList( destinations );
			}
		} while( path == null && System.currentTimeMillis( ) < stopTime && attempt < 10 );

		if( path == null )
			unreachables.clear( );

		return path;
	}
}
