package com.vulcannis.icfp2002.game;

import com.vulcannis.icfp2002.util.*;

public abstract class ClientAction
{
	protected ClientAction( final long bid, final String verb )
	{
		this.bid = bid;
		this.verb = verb;
	}
	
	public final String toString( )
	{
		StringBuffer buffer = new StringBuffer( );
		buffer.append( bid );
		buffer.append( " " );
		buffer.append( verb );
		buffer.append( " " );
		buffer.append( getActionParameters( ) );
		return buffer.toString( );
	}
	
	public final long getBid( )
	{
		return bid;
	}
	
	public abstract boolean wasSuccessful( final GameState state );
	
	public boolean equals( final Object other )
	{
		if( other != null && other instanceof ClientAction ) {
			final ClientAction a = (ClientAction)other;
			return a.bid == bid && a.verb.equals( verb ) && a.getActionParameters( ).equals( getActionParameters( ) );
		}
		return false;
	}
	
	protected abstract String getActionParameters( );
	
	protected long bid;
	protected String verb;
}
