package com.vulcannis.icfp2002.game;

import java.io.*;

public final class ClientConfig
{
	/**
	 * @param u Unique identifier
	 * @param c Maximum capacity
	 * @param m Initial amount of money
	 */
	public ClientConfig(BufferedReader in) throws IOException, InvalidStateInformationException {
		String[] splitLine = in.readLine().split(" ");
		try {
			uid = Integer.parseInt(splitLine[0]);
		}
		catch (NumberFormatException e) {
			throw new InvalidStateInformationException("Bad client config data \"" + splitLine[0] + "\"");
		}
		try {
			capacity = Integer.parseInt(splitLine[1]);
		}
		catch (NumberFormatException e) {
			throw new InvalidStateInformationException("Bad client config data \"" + splitLine[1] + "\"");
		}
		try {
			money = Long.parseLong(splitLine[2]);
		}
		catch (NumberFormatException e) {
			throw new InvalidStateInformationException("Bad client config data \"" + splitLine[2] + "\"");
		}
	}

	public int getUid() {
		return uid;
	}
	
	public int getCapacity() {
		return capacity;
	}
	
	public long getMoney() {
		return money;
	}

	private int uid;
	private int capacity;
	private long money;
}
