package com.vulcannis.icfp2002.game;

import java.util.*;

import com.vulcannis.icfp2002.util.*;

public final class DropAction extends ClientAction {
	public DropAction( final long bid, final Set packages )
	{
		super( bid, DROP_VERB );
		this.packages = packages;

		StringBuffer buffer = new StringBuffer( );
		final Iterator it = packages.iterator( );
		if( it.hasNext( ) )
			buffer.append( ( (Package)it.next( ) ).getId( ) );
		while( it.hasNext( ) ) {
			buffer.append( " " );
			final Package pack = (Package)it.next( );
			buffer.append( pack.getId( ) );
		}
		params = buffer.toString( );
	}
	
	protected String getActionParameters( )
	{
		return params;
	}

	public Point getResultingPosition( final Point from )
	{
		return from;
	}

	public boolean wasSuccessful( final GameState state )
	{
		return SetUtil.isIntersectionEmpty( state.getOurPlayer( ).getPackages( ), packages );
	}
	
	private String params;
	private Set packages;
	
	private static final String DROP_VERB = "Drop";
}
