package com.vulcannis.icfp2002.game;

import com.vulcannis.icfp2002.util.*;

public final class MoveAction extends ClientAction {
	public MoveAction( final long bid, final Direction direction, final GameState state )
	{
		super( bid, MOVE_VERB );
		this.direction = direction;
		destination = direction.move( state.getOurPlayer( ).getLocation( ) );
	}
	
	protected String getActionParameters( )
	{
		return direction.toString( );
	}

	public Point getResultingPosition( final Point from )
	{
		return direction.move( from );
	}

	public boolean wasSuccessful( final GameState state )
	{
		return state.getOurPlayer( ).getLocation( ).equals( destination );
	}
	
	private Direction direction;
	private Point destination;
	
	private final static String MOVE_VERB = "Move";
}
