package com.vulcannis.icfp2002.game;

import com.vulcannis.icfp2002.util.*;

public final class Package
{
	public Package( final Point location )
	{
		id = -1;
		destination = null;
		weight = -1;
		this.location = location;
		locationState = POSSIBLE_DROPPED;
	}
	
	public Package( final int id, final Point destination, final int weight )
	{
		this.id = id;
		this.destination = destination;
		this.weight = weight;
		location = null;
		locationState = UNKNOWN;
	}
	
	public int getId( )
	{
		return id;
	}
	
	public Point getDestination( )
	{
		return destination;
	}
	
	public void setLocation( final Point value )
	{
		location = value;
	}
	
	public Point getLocation( )
	{
		return location;
	}
	
	public int getWeight( )
	{
		return weight;
	}
	
	public void setLocationState( final int value )
	{
		locationState = value;
	}
	
	public int getLocationState( )
	{
		return locationState;
	}
	
	public boolean equals( final Object other )
	{
		if( other != null && other instanceof Package ) {
			final Package pack = (Package)other;
			return id == pack.id;
		}
		return false;
	}
	
	public int hashCode( )
	{
		return id;
	}
	
	public String toString( )
	{
		final StringBuffer buffer = new StringBuffer( );
//		buffer.append( "Package #" );
		buffer.append( id );
/*		buffer.append( " State: " );
		buffer.append( STATES[ locationState ] );
		buffer.append( " @" );
		buffer.append( location );
		buffer.append( " Weight: " );
		buffer.append( weight );
		buffer.append( " Dest: " );
		buffer.append( destination );
*/		return buffer.toString( );
	}
	
	private int id;
	private Point destination;
	private int weight;
	private Point location;
	private int locationState;
	
	public static final int UNKNOWN = 0;
	public static final int KNOWN_DROPPED = 1;
	public static final int POSSIBLE_DROPPED = 2;
	public static final int KNOWN_CARRIED = 3;
	
	private static final String STATES[ ] = { "Unknown", "Known dropped", "Possible dropped", "Known carried" };
}
