package com.vulcannis.icfp2002.game;

import java.io.*;
import java.util.*;

import com.vulcannis.icfp2002.net.GameOverException;
import com.vulcannis.icfp2002.util.*;

public final class PackageUpdate
{
	/**
	 * Creates a package update given the text for
	 * a package update message
	 */
	public PackageUpdate( final BufferedReader reader ) throws IOException, GameOverException
	{
		final String text = reader.readLine( );
		if( text == null || text.indexOf( "died" ) != -1 )
			throw new GameOverException( );
System.out.println( "Package Update: \"" + text + "\"" );
		final StringTokenizer tokenizer = new StringTokenizer( text );
		packages = new HashSet( );
		while( tokenizer.hasMoreTokens( ) ) {
			final String id = tokenizer.nextToken( );
			final String x = tokenizer.nextToken( );
			final String y = tokenizer.nextToken( );
			final String weight = tokenizer.nextToken( );
			packages.add( new Package( Integer.parseInt( id ), new Point( Integer.parseInt( x ), Integer.parseInt( y ) ), Integer.parseInt( weight ) ) );
		}
	}
	
	public Set getPackages( )
	{
		return packages;
	}
	
	public int getCount( )
	{
		return packages.size( );
	}
	
	public Set packages;
}
