package com.vulcannis.icfp2002.game;

import java.util.*;

import com.vulcannis.icfp2002.game.*;
import com.vulcannis.icfp2002.util.Point;

public final class Path
{
	public Path( final Point points[ ] ) throws InvalidDirectionException
	{
		if( points.length > 0 )
			destination = points[ points.length - 1 ];
		else
			destination = null;
		location = points.length - 1;
		dirs = new Direction[ location ];
		for( int loop = 1; loop < points.length; loop++ )
			dirs[ location - loop ] = Direction.delta( points[ loop - 1 ], points[ loop ] );
	}
	
	public int getLength( )
	{
		return location;
	}
	
	public boolean haveArrived( )
	{
		return location == 0;
	}
	
	public Direction getNext( )
	{
		return dirs[ --location ];
	}
	
	public Point getDestination( )
	{
		return destination;
	}
	
	public String toString( )
	{
		final StringBuffer buffer = new StringBuffer( );
		
		buffer.append( "Destination: " );
		buffer.append( destination );
		buffer.append( " Length: " );
		buffer.append( dirs.length );
		buffer.append( " " );
		
		buffer.append( "{ " );
		for( int loop = location - 1; loop >= 0; loop-- ) {
			buffer.append( dirs[ loop ].toString( ) );
			if( loop > 0 )
				buffer.append( ", " );
		}
/*		final Iterator it = Arrays.asList( points ).iterator( );
		if( it.hasNext( ) )
			buffer.append( it.next( ) );
		while( it.hasNext( ) ) {
			buffer.append( ", " );
			buffer.append( it.next( ) );
		}
*/		buffer.append( " }" );
		return buffer.toString( );
	}
	
	private int location;
	private final Direction dirs[ ];
	private final Point destination;
}
