package com.vulcannis.icfp2002.game;

import java.util.*;

import com.vulcannis.icfp2002.util.*;

public final class PickupAction extends ClientAction {
	public PickupAction( final long bid, final Set packages )
	{
		super( bid, PICKUP_VERB );
		this.packages = packages;

		final StringBuffer buffer = new StringBuffer( );
		final Iterator it = packages.iterator( );
		if( it.hasNext( ) )
			buffer.append( ( (Package)it.next( ) ).getId( ) );
		while( it.hasNext( ) ) {
			buffer.append( " " );
			final Package pack = (Package)it.next( );
			buffer.append( pack.getId( ) );
		}
		params = buffer.toString( );
	}
	
	protected String getActionParameters( )
	{
		return params;
	}

	public Point getResultingPosition( final Point from )
	{
		return from;
	}

	public boolean wasSuccessful( final GameState state )
	{
		return packages.isEmpty( ) || !SetUtil.isIntersectionEmpty( packages, state.getOurPlayer( ).getPackages( ) );
	}
	
	private String params;
	private Set packages;
	
	private static final String PICKUP_VERB = "Pick";
}
