package com.vulcannis.icfp2002.game;

import com.vulcannis.icfp2002.util.*;

public final class PlayerAbsoluteMove extends PlayerAction {
	/**
	 * @param o The opponent uid.
	 * @param x The absolute X location placement of this opponent.
	 * @param y The absolute Y location placement of this opponent.
	 */
	public PlayerAbsoluteMove(int o, int x, int y) {
		super(o);
		this.x = x;
		this.y = y;
	}
	
	public int getX() {
		return x;
	}

	public int getY() {
		return y;
	}
	
	public Point getPoint() {
		return new Point(x, y);
	}
	
	public void updatePlayer(Player p) {
		p.setLocation(new Point(x, y));
		p.setStuck( false );
	}

	private int x;
	private int y;
}
