package com.vulcannis.icfp2002.game;

import com.vulcannis.icfp2002.util.*;

public final class PlayerDrop extends PlayerAction implements PackageAction {
	/**
	 * @param o The opponent uid.
	 * @param p The package id the opponent picked up.
	 */
	public PlayerDrop(int o, int p) {
		super(o);
		pack = p;
	}
	
	public void updatePlayer( Player p )
	{
		p.setStuck( false );
		carrier = p;
		location = p.getLocation( );
	}
	
	public int getPackage() {
		return pack;
	}

	public int getPackageID( )
	{
		return pack;
	}

	public PackageCarrier getCarrier( )
	{
		return carrier;
	}

	public boolean isPickup( )
	{
		return false;
	}
	
	public Point getLocation( )
	{
		return location;
	}
	
	private int pack;
	private PackageCarrier carrier;
	private Point location;
}
