package com.vulcannis.icfp2002.util;

public final class AnyDestination implements Destination {
	public AnyDestination( final Point locs[ ] )
	{
		this.locs = locs;
	}

	/**
	 * Would be nice to make this a constant-time
	 * check, such as with a set of Points.  Time it
	 * takes to new them however may wipe out any gains.
	 */
	public boolean haveArrived( final int x, final int y )
	{
		for( int loop = 0; loop < locs.length; loop++ )
			if( locs[ loop ].getX( ) == x && locs[ loop ].getY( ) == y )
				return true;
		return false;
	}

	public int computeCost( final int x, final int y )
	{
		if( locs.length == 0 )
			return 0;
		int minCost = computeCost( x, y, locs[ 0 ] );
		for( int loop = 1; loop < locs.length; loop++ ) {
			minCost = Math.min( minCost, computeCost( x, y, locs[ loop ] ) );
		}
		return minCost;
	}
	
	private int computeCost( final int x, final int y, final Point p )
	{
		int delx = x - p.getX( );
		int dely = y - p.getY( );
//		int value = (int)Math.sqrt( delx * delx + dely * dely );
//		return value;
		return ( Math.abs( delx ) + Math.abs( dely ) ) * 2;
	}
	
	private final Point locs[ ];
}
