package com.vulcannis.icfp2002.util;

public final class Point
{
	public Point( int x, int y )
	{
		this.x = x;
		this.y = y;
	}
	
	public int getX( )
	{
		return x;
	}
	
	public int getY( )
	{
		return y;
	}
	
	public boolean isAdjacentTo( final Point other )
	{
		final int deltaX = x - other.x;
		final int deltaY = y - other.y;
		return Math.abs( deltaX ) + Math.abs( deltaY ) == 1;
	}
	
	public String toString( )
	{
		StringBuffer buffer = new StringBuffer( "( " );
		buffer.append( x );
		buffer.append( ", " );
		buffer.append( y );
		buffer.append( " )" );
		return buffer.toString( );
	}
	
	public boolean equals( final Object other )
	{
		if( other != null && other instanceof Point ) {
			final Point p = (Point)other;
			return x == p.x && y == p.y;
		}
		return false;
	}
	
	public int hashCode( )
	{
		return x ^ ~y;
	}
	
	private int x, y;
}
