package com.vulcannis.icfp2002.util;

import java.util.*;

public class SetUtil {
	public static boolean isIntersectionEmpty( final Set first, final Set second )
	{
		if( first.size( ) < second.size( ) )
			return doIntersectionSize( first, second ) == 0;
		else
			return doIntersectionSize( second, first ) == 0;
	}
	
	/**
	 * @return true if first is a subset of second.
	 */
	public static boolean isSubset( final Set first, final Set second )
	{
		final Iterator it = first.iterator( );
		while( it.hasNext( ) )
			if( !second.contains( it.next( ) ) )
				return false;
		return true;
	}
	
	/**
	 * @return the set of a - b.
	 */
	public static Set subtraction( final Set a, final Set b )
	{
		Set returnSet = new HashSet();
		final Iterator it = a.iterator( );
		while( it.hasNext( ) ) {
			Object o = it.next();
			if( !b.contains( o ) )
				returnSet.add(o);
		}
		return returnSet;
	}
	
	/**
	 * @param first the smaller set.
	 * @param second the larger set.
	 * @return the number of elements that are in both sets.
	 */
	private static int doIntersectionSize( final Set first, final Set second )
	{
		int count = 0;
		final Iterator it = first.iterator( );
		while( it.hasNext( ) )
			if( second.contains( it.next( ) ) )
				count++;
		return count;
	}
}
