package com.vulcannis.icfp2002.util;

public final class SingleDestination implements Destination {
	public SingleDestination( final int x, final int y )
	{
		this.x = x;
		this.y = y;
	}
	
	public SingleDestination( final Point loc )
	{
		this.x = loc.getX( );
		this.y = loc.getY( );
	}
	
	public boolean haveArrived( int x, int y )
	{
		return x == this.x && y == this.y;
	}

	public int computeCost( int x, int y )
	{
		int delx = x - this.x;
		int dely = y - this.y;
//		int value = (int)Math.sqrt( delx * delx + dely * dely );
//		return value;
		return ( Math.abs( delx ) + Math.abs( dely ) ) * 2;
	}
	
	public String toString( )
	{
		return "Destination: ( " + x + ", " + y + " )";
	}
	
	private final int x, y;
}
